Silence erroneous hlint warning
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Block \
61         htools/Ganeti/Block/Drbd \
62         htools/Ganeti/Confd \
63         htools/Ganeti/DataCollectors \
64         htools/Ganeti/HTools \
65         htools/Ganeti/HTools/Backend \
66         htools/Ganeti/HTools/Program \
67         htools/Ganeti/Query \
68         htest \
69         htest/Test \
70         htest/Test/Ganeti \
71         htest/Test/Ganeti/Block \
72         htest/Test/Ganeti/Block/Drbd \
73         htest/Test/Ganeti/Confd \
74         htest/Test/Ganeti/HTools \
75         htest/Test/Ganeti/HTools/Backend \
76         htest/Test/Ganeti/Query
77
78 DIRS = \
79         $(HTOOLS_DIRS) \
80         autotools \
81         daemons \
82         devel \
83         doc \
84         doc/examples \
85         doc/examples/gnt-debug \
86         doc/examples/hooks \
87         htest/data \
88         htest/data/rapi \
89         htest/shelltests \
90         lib \
91         lib/build \
92         lib/client \
93         lib/confd \
94         lib/http \
95         lib/hypervisor \
96         lib/impexpd \
97         lib/masterd \
98         lib/rapi \
99         lib/server \
100         lib/tools \
101         lib/utils \
102         lib/watcher \
103         man \
104         qa \
105         test \
106         test/data \
107         test/data/ovfdata \
108         test/data/ovfdata/other \
109         tools
110
111 ALL_APIDOC_HS_DIRS = \
112         $(APIDOC_HS_DIR) \
113         $(APIDOC_HS_DIR)/Ganeti \
114         $(APIDOC_HS_DIR)/Ganeti/Block \
115         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
116         $(APIDOC_HS_DIR)/Ganeti/Confd \
117         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
118         $(APIDOC_HS_DIR)/Ganeti/HTools \
119         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
120         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
121         $(APIDOC_HS_DIR)/Ganeti/Query
122
123 BUILDTIME_DIR_AUTOCREATE = \
124         scripts \
125         $(APIDOC_DIR) \
126         $(ALL_APIDOC_HS_DIRS) \
127         $(APIDOC_PY_DIR) \
128         $(COVERAGE_DIR) \
129         $(COVERAGE_HS_DIR) \
130         $(COVERAGE_PY_DIR) \
131         .hpc
132
133 BUILDTIME_DIRS = \
134         $(BUILDTIME_DIR_AUTOCREATE) \
135         doc/html
136
137 DIRCHECK_EXCLUDE = \
138         $(BUILDTIME_DIRS) \
139         ganeti-[0-9]*.[0-9]*.[0-9]* \
140         doc/html/_* \
141         autom4te.cache
142
143 # some helper vars
144 COVERAGE_DIR = doc/coverage
145 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
146 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
147 APIDOC_DIR = doc/api
148 APIDOC_PY_DIR = $(APIDOC_DIR)/py
149 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
150
151 MAINTAINERCLEANFILES = \
152         $(docpng) \
153         $(maninput) \
154         doc/install-quick.rst \
155         doc/news.rst \
156         doc/upgrade.rst \
157         vcs-version
158
159 maintainer-clean-local:
160         rm -rf $(BUILDTIME_DIRS)
161
162 CLEANFILES = \
163         $(addsuffix /*.py[co],$(DIRS)) \
164         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
165         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
166         $(PYTHON_BOOTSTRAP) \
167         epydoc.conf \
168         $(REPLACE_VARS_SED) \
169         $(SHELL_ENV_INIT) \
170         daemons/daemon-util \
171         daemons/ganeti-cleaner \
172         $(BUILT_EXAMPLES) \
173         doc/examples/bash_completion \
174         doc/examples/bash_completion-debug \
175         lib/_generated_rpc.py \
176         $(man_MANS) \
177         $(manhtml) \
178         tools/kvm-ifup \
179         tools/vcluster-setup \
180         stamp-directories \
181         stamp-srclinks \
182         $(nodist_pkgpython_PYTHON) \
183         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
184         $(HS_BUILT_TEST_HELPERS) \
185         htools/ganeti-confd \
186         .hpc/*.mix htools/*.tix htest/*.tix \
187         doc/hs-lint.html
188
189 GENERATED_FILES = \
190         $(built_base_sources) \
191         $(BUILT_PYTHON_SOURCES) \
192         $(PYTHON_BOOTSTRAP)
193
194 HTOOLS_GENERATED_FILES =
195 if WANT_HTOOLS
196 HTOOLS_GENERATED_FILES += $(HS_PROGS)
197 if ENABLE_CONFD
198 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
199 endif
200 endif
201
202 built_base_sources = \
203         stamp-directories \
204         stamp-srclinks
205
206 built_python_base_sources = \
207         lib/_autoconf.py \
208         lib/_vcsversion.py
209
210 BUILT_PYTHON_SOURCES = \
211         $(built_python_base_sources) \
212         lib/_generated_rpc.py
213
214 # Generating the RPC wrappers depends on many things, so make sure
215 # it's built at the end of the built sources
216 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
217
218 # these are all built from the underlying %.in sources
219 BUILT_EXAMPLES = \
220         doc/examples/ganeti-kvm-poweroff.initd \
221         doc/examples/ganeti.cron \
222         doc/examples/ganeti.initd \
223         doc/examples/ganeti-master-role.ocf \
224         doc/examples/ganeti-node-role.ocf \
225         doc/examples/gnt-config-backup \
226         doc/examples/hooks/ipsec
227
228 nodist_pkgpython_PYTHON = \
229         $(BUILT_PYTHON_SOURCES)
230
231 noinst_PYTHON = \
232         lib/build/__init__.py \
233         lib/build/shell_example_lexer.py \
234         lib/build/sphinx_ext.py
235
236 pkgpython_PYTHON = \
237         lib/__init__.py \
238         lib/asyncnotifier.py \
239         lib/backend.py \
240         lib/bdev.py \
241         lib/bootstrap.py \
242         lib/cli.py \
243         lib/cmdlib.py \
244         lib/compat.py \
245         lib/config.py \
246         lib/constants.py \
247         lib/daemon.py \
248         lib/errors.py \
249         lib/ht.py \
250         lib/jqueue.py \
251         lib/jstore.py \
252         lib/locking.py \
253         lib/luxi.py \
254         lib/mcpu.py \
255         lib/netutils.py \
256         lib/objects.py \
257         lib/objectutils.py \
258         lib/opcodes.py \
259         lib/ovf.py \
260         lib/pathutils.py \
261         lib/qlang.py \
262         lib/query.py \
263         lib/rpc.py \
264         lib/rpc_defs.py \
265         lib/runtime.py \
266         lib/serializer.py \
267         lib/ssconf.py \
268         lib/ssh.py \
269         lib/storage.py \
270         lib/uidpool.py \
271         lib/vcluster.py \
272         lib/network.py \
273         lib/workerpool.py
274
275 client_PYTHON = \
276         lib/client/__init__.py \
277         lib/client/gnt_backup.py \
278         lib/client/gnt_cluster.py \
279         lib/client/gnt_debug.py \
280         lib/client/gnt_group.py \
281         lib/client/gnt_instance.py \
282         lib/client/gnt_job.py \
283         lib/client/gnt_node.py \
284         lib/client/gnt_network.py \
285         lib/client/gnt_os.py
286
287 hypervisor_PYTHON = \
288         lib/hypervisor/__init__.py \
289         lib/hypervisor/hv_base.py \
290         lib/hypervisor/hv_chroot.py \
291         lib/hypervisor/hv_fake.py \
292         lib/hypervisor/hv_kvm.py \
293         lib/hypervisor/hv_lxc.py \
294         lib/hypervisor/hv_xen.py
295
296 rapi_PYTHON = \
297         lib/rapi/__init__.py \
298         lib/rapi/baserlib.py \
299         lib/rapi/client.py \
300         lib/rapi/client_utils.py \
301         lib/rapi/connector.py \
302         lib/rapi/rlib2.py \
303         lib/rapi/testutils.py
304
305 http_PYTHON = \
306         lib/http/__init__.py \
307         lib/http/auth.py \
308         lib/http/client.py \
309         lib/http/server.py
310
311 confd_PYTHON = \
312         lib/confd/__init__.py \
313         lib/confd/client.py
314
315 masterd_PYTHON = \
316         lib/masterd/__init__.py \
317         lib/masterd/iallocator.py \
318         lib/masterd/instance.py
319
320 impexpd_PYTHON = \
321         lib/impexpd/__init__.py
322
323 watcher_PYTHON = \
324         lib/watcher/__init__.py \
325         lib/watcher/nodemaint.py \
326         lib/watcher/state.py
327
328 server_PYTHON = \
329         lib/server/__init__.py \
330         lib/server/masterd.py \
331         lib/server/noded.py \
332         lib/server/rapi.py
333
334 pytools_PYTHON = \
335         lib/tools/__init__.py \
336         lib/tools/ensure_dirs.py \
337         lib/tools/node_cleanup.py \
338         lib/tools/node_daemon_setup.py \
339         lib/tools/prepare_node_join.py
340
341 utils_PYTHON = \
342         lib/utils/__init__.py \
343         lib/utils/algo.py \
344         lib/utils/filelock.py \
345         lib/utils/hash.py \
346         lib/utils/io.py \
347         lib/utils/log.py \
348         lib/utils/mlock.py \
349         lib/utils/nodesetup.py \
350         lib/utils/process.py \
351         lib/utils/retry.py \
352         lib/utils/text.py \
353         lib/utils/wrapper.py \
354         lib/utils/x509.py
355
356 docrst = \
357         doc/admin.rst \
358         doc/cluster-merge.rst \
359         doc/design-2.0.rst \
360         doc/design-2.1.rst \
361         doc/design-2.2.rst \
362         doc/design-2.3.rst \
363         doc/design-2.4.rst \
364         doc/design-2.5.rst \
365         doc/design-2.6.rst \
366         doc/design-2.7.rst \
367         doc/design-autorepair.rst \
368         doc/design-bulk-create.rst \
369         doc/design-chained-jobs.rst \
370         doc/design-cpu-pinning.rst \
371         doc/design-draft.rst \
372         doc/design-htools-2.3.rst \
373         doc/design-http-server.rst \
374         doc/design-impexp2.rst \
375         doc/design-lu-generated-jobs.rst \
376         doc/design-linuxha.rst \
377         doc/design-multi-reloc.rst \
378         doc/design-network.rst \
379         doc/design-node-add.rst \
380         doc/design-oob.rst \
381         doc/design-ovf-support.rst \
382         doc/design-opportunistic-locking.rst \
383         doc/design-partitioned.rst \
384         doc/design-query-splitting.rst \
385         doc/design-query2.rst \
386         doc/design-remote-commands.rst \
387         doc/design-resource-model.rst \
388         doc/design-shared-storage.rst \
389         doc/design-monitoring-agent.rst \
390         doc/design-virtual-clusters.rst \
391         doc/design-x509-ca.rst \
392         doc/devnotes.rst \
393         doc/glossary.rst \
394         doc/hooks.rst \
395         doc/iallocator.rst \
396         doc/index.rst \
397         doc/install-quick.rst \
398         doc/install.rst \
399         doc/locking.rst \
400         doc/move-instance.rst \
401         doc/news.rst \
402         doc/ovfconverter.rst \
403         doc/rapi.rst \
404         doc/security.rst \
405         doc/upgrade.rst \
406         doc/virtual-cluster.rst \
407         doc/walkthrough.rst
408
409 HS_PROGS = htools/htools htools/mon-collector
410 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
411 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
412
413 HS_ALL_PROGS = \
414         $(HS_PROGS) \
415         htest/hpc-htools \
416         htest/hpc-mon-collector \
417         htest/test \
418         htools/hconfd \
419         htools/rpc-test
420
421 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
422 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
423
424 HFLAGS = \
425         -O -Wall -Werror -ihtools \
426         -fwarn-monomorphism-restriction \
427         -fwarn-tabs \
428         $(GHC_BYVERSION_FLAGS)
429
430 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
431 HEXTRA =
432 # internal extra flags (used for htest/test mainly)
433 HEXTRA_INT =
434 # exclude options for coverage reports
435 HPCEXCL = --exclude Main \
436         --exclude Ganeti.Constants \
437         --exclude Ganeti.HTools.QC \
438         --exclude Ganeti.THH \
439         --exclude Ganeti.Version \
440         --exclude Test.Ganeti.Attoparsec \
441         --exclude Test.Ganeti.TestCommon \
442         --exclude Test.Ganeti.TestHTools \
443         --exclude Test.Ganeti.TestHelper \
444         --exclude Test.Ganeti.TestImports \
445         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
446
447 HS_LIB_SRCS = \
448         htools/Ganeti/Block/Drbd/Types.hs \
449         htools/Ganeti/Block/Drbd/Parser.hs \
450         htools/Ganeti/BasicTypes.hs \
451         htools/Ganeti/Common.hs \
452         htools/Ganeti/Compat.hs \
453         htools/Ganeti/Confd/Client.hs \
454         htools/Ganeti/Confd/Server.hs \
455         htools/Ganeti/Confd/Types.hs \
456         htools/Ganeti/Confd/Utils.hs \
457         htools/Ganeti/Config.hs \
458         htools/Ganeti/Daemon.hs \
459         htools/Ganeti/DataCollectors/CLI.hs \
460         htools/Ganeti/DataCollectors/Drbd.hs \
461         htools/Ganeti/DataCollectors/Program.hs \
462         htools/Ganeti/Errors.hs \
463         htools/Ganeti/HTools/Backend/IAlloc.hs \
464         htools/Ganeti/HTools/Backend/Luxi.hs \
465         htools/Ganeti/HTools/Backend/Rapi.hs \
466         htools/Ganeti/HTools/Backend/Simu.hs \
467         htools/Ganeti/HTools/Backend/Text.hs \
468         htools/Ganeti/HTools/CLI.hs \
469         htools/Ganeti/HTools/Cluster.hs \
470         htools/Ganeti/HTools/Container.hs \
471         htools/Ganeti/HTools/ExtLoader.hs \
472         htools/Ganeti/HTools/Graph.hs \
473         htools/Ganeti/HTools/Group.hs \
474         htools/Ganeti/HTools/Instance.hs \
475         htools/Ganeti/HTools/Loader.hs \
476         htools/Ganeti/HTools/Node.hs \
477         htools/Ganeti/HTools/PeerMap.hs \
478         htools/Ganeti/HTools/Program.hs \
479         htools/Ganeti/HTools/Program/Hail.hs \
480         htools/Ganeti/HTools/Program/Hbal.hs \
481         htools/Ganeti/HTools/Program/Hcheck.hs \
482         htools/Ganeti/HTools/Program/Hinfo.hs \
483         htools/Ganeti/HTools/Program/Hscan.hs \
484         htools/Ganeti/HTools/Program/Hspace.hs \
485         htools/Ganeti/HTools/Program/Hroller.hs \
486         htools/Ganeti/HTools/Types.hs \
487         htools/Ganeti/Hash.hs \
488         htools/Ganeti/JQueue.hs \
489         htools/Ganeti/JSON.hs \
490         htools/Ganeti/Jobs.hs \
491         htools/Ganeti/Logging.hs \
492         htools/Ganeti/Luxi.hs \
493         htools/Ganeti/Network.hs \
494         htools/Ganeti/Objects.hs \
495         htools/Ganeti/OpCodes.hs \
496         htools/Ganeti/OpParams.hs \
497         htools/Ganeti/Path.hs \
498         htools/Ganeti/Query/Common.hs \
499         htools/Ganeti/Query/Filter.hs \
500         htools/Ganeti/Query/Group.hs \
501         htools/Ganeti/Query/Job.hs \
502         htools/Ganeti/Query/Language.hs \
503         htools/Ganeti/Query/Node.hs \
504         htools/Ganeti/Query/Query.hs \
505         htools/Ganeti/Query/Server.hs \
506         htools/Ganeti/Query/Types.hs \
507         htools/Ganeti/Rpc.hs \
508         htools/Ganeti/Runtime.hs \
509         htools/Ganeti/Ssconf.hs \
510         htools/Ganeti/THH.hs \
511         htools/Ganeti/Types.hs \
512         htools/Ganeti/Utils.hs
513
514 HS_TEST_SRCS = \
515         htest/Test/Ganeti/Attoparsec.hs \
516         htest/Test/Ganeti/BasicTypes.hs \
517         htest/Test/Ganeti/Block/Drbd/Parser.hs \
518         htest/Test/Ganeti/Block/Drbd/Types.hs \
519         htest/Test/Ganeti/Common.hs \
520         htest/Test/Ganeti/Confd/Types.hs \
521         htest/Test/Ganeti/Confd/Utils.hs \
522         htest/Test/Ganeti/Daemon.hs \
523         htest/Test/Ganeti/Errors.hs \
524         htest/Test/Ganeti/HTools/Backend/Simu.hs \
525         htest/Test/Ganeti/HTools/Backend/Text.hs \
526         htest/Test/Ganeti/HTools/CLI.hs \
527         htest/Test/Ganeti/HTools/Cluster.hs \
528         htest/Test/Ganeti/HTools/Container.hs \
529         htest/Test/Ganeti/HTools/Graph.hs \
530         htest/Test/Ganeti/HTools/Instance.hs \
531         htest/Test/Ganeti/HTools/Loader.hs \
532         htest/Test/Ganeti/HTools/Node.hs \
533         htest/Test/Ganeti/HTools/PeerMap.hs \
534         htest/Test/Ganeti/HTools/Types.hs \
535         htest/Test/Ganeti/JSON.hs \
536         htest/Test/Ganeti/Jobs.hs \
537         htest/Test/Ganeti/JQueue.hs \
538         htest/Test/Ganeti/Luxi.hs \
539         htest/Test/Ganeti/Network.hs \
540         htest/Test/Ganeti/Objects.hs \
541         htest/Test/Ganeti/OpCodes.hs \
542         htest/Test/Ganeti/Query/Filter.hs \
543         htest/Test/Ganeti/Query/Language.hs \
544         htest/Test/Ganeti/Query/Query.hs \
545         htest/Test/Ganeti/Rpc.hs \
546         htest/Test/Ganeti/Ssconf.hs \
547         htest/Test/Ganeti/THH.hs \
548         htest/Test/Ganeti/TestCommon.hs \
549         htest/Test/Ganeti/TestHTools.hs \
550         htest/Test/Ganeti/TestHelper.hs \
551         htest/Test/Ganeti/Types.hs \
552         htest/Test/Ganeti/Utils.hs
553
554 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
555
556 HS_BUILT_SRCS = \
557         htest/Test/Ganeti/TestImports.hs \
558         htools/Ganeti/Constants.hs \
559         htools/Ganeti/Version.hs
560 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
561
562 $(RUN_IN_TEMPDIR): | stamp-directories
563
564 # Note: we use here an order-only prerequisite, as the contents of
565 # _autoconf.py are not actually influencing the html build output: it
566 # has to exist in order for the sphinx module to be loaded
567 # successfully, but we certainly don't want the docs to be rebuilt if
568 # it changes
569 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
570         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
571         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
572         | $(BUILT_PYTHON_SOURCES)
573         @test -n "$(SPHINX)" || \
574             { echo 'sphinx-build' not found during configure; exit 1; }
575         @mkdir_p@ $(dir $@)
576         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
577             -d . \
578             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
579             -D release="$(PACKAGE_VERSION)" \
580             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
581         rm -f doc/html/.buildinfo doc/html/objects.inv
582         touch $@
583
584 doc/html: doc/html/index.html
585
586 doc/install-quick.rst: INSTALL
587 doc/news.rst: NEWS
588 doc/upgrade.rst: UPGRADE
589
590 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
591         set -e; \
592         { echo '.. This file is automatically updated at build time from $<.'; \
593           echo '.. Do not edit.'; \
594           echo; \
595           cat $<; \
596         } > $@
597
598 docdot = \
599         doc/arch-2.0.dot \
600         doc/design-2.1-lock-acquire.dot \
601         doc/design-2.1-lock-release.dot
602
603 docpng = $(patsubst %.dot,%.png,$(docdot))
604
605 # Things to build but not to install (add it to EXTRA_DIST if it should be
606 # distributed)
607 noinst_DATA = \
608         doc/html \
609         $(BUILT_EXAMPLES) \
610         doc/examples/bash_completion \
611         doc/examples/bash_completion-debug \
612         $(manhtml)
613
614 gnt_scripts = \
615         scripts/gnt-backup \
616         scripts/gnt-cluster \
617         scripts/gnt-debug \
618         scripts/gnt-group \
619         scripts/gnt-instance \
620         scripts/gnt-job \
621         scripts/gnt-network \
622         scripts/gnt-node \
623         scripts/gnt-os
624
625 PYTHON_BOOTSTRAP_SBIN = \
626         daemons/ganeti-masterd \
627         daemons/ganeti-noded \
628         daemons/ganeti-rapi \
629         daemons/ganeti-watcher \
630         $(gnt_scripts)
631
632 PYTHON_BOOTSTRAP = \
633         $(PYTHON_BOOTSTRAP_SBIN) \
634         tools/ensure-dirs \
635         tools/node-cleanup \
636         tools/node-daemon-setup \
637         tools/prepare-node-join
638
639 qa_scripts = \
640         qa/__init__.py \
641         qa/ganeti-qa.py \
642         qa/qa_cluster.py \
643         qa/qa_config.py \
644         qa/qa_daemon.py \
645         qa/qa_env.py \
646         qa/qa_error.py \
647         qa/qa_group.py \
648         qa/qa_instance.py \
649         qa/qa_job.py \
650         qa/qa_node.py \
651         qa/qa_os.py \
652         qa/qa_rapi.py \
653         qa/qa_tags.py \
654         qa/qa_utils.py
655
656 bin_SCRIPTS =
657 if WANT_HTOOLS
658 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
659 install-exec-hook:
660         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
661 # FIXME: this is a hardcoded logic, instead of auto-resolving
662         $(LN_S) -f ../../../bin/htools \
663           $(DESTDIR)$(iallocatorsdir)/hail
664         for role in $(HS_BIN_ROLES); do \
665           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
666         done
667 endif
668
669 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
670         @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
671           echo "Error: cannot run unittests without the development" \
672                " libraries (see devnotes.rst)" 1>&2; \
673           exit 1; \
674         fi
675         @rm -f $(notdir $@).tix
676         $(GHC) --make \
677           $(HFLAGS) \
678           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
679           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
680           $(HEXTRA) $(HEXTRA_INT) $@
681         @touch "$@"
682
683 # for the htest/test binary, we need to enable profiling/coverage
684 htest/test: HEXTRA_INT=-fhpc -ihtest
685
686 # we compile the hpc-htools binary with the program coverage
687 htest/hpc-htools: HEXTRA_INT=-fhpc
688
689 # we compile the hpc-mon-collector binary with the program coverage
690 htest/hpc-mon-collector: HEXTRA_INT=-fhpc
691
692 # test dependency
693 htest/offline-tests.sh: htest/hpc-htools htest/hpc-mon-collector
694
695 # rules for building profiling-enabled versions of the haskell
696 # programs: hs-prof does the full two-step build, whereas
697 # hs-prof-quick does only the final rebuild (hs-prof must have been
698 # run before)
699 .PHONY: hs-prof hs-prof-quick
700 hs-prof:
701         @if [ -z "$(TARGET)" ]; then \
702           echo "You need to define TARGET when running this rule" 1>&2; \
703           exit 1; \
704         fi
705         $(MAKE) $(AM_MAKEFLAGS) clean
706         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
707         rm -f $(HS_ALL_PROGS)
708         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
709
710 hs-prof-quick:
711         @if [ -z "$(TARGET)" ]; then \
712           echo "You need to define TARGET when running this rule" 1>&2; \
713           exit 1; \
714         fi
715         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
716
717 dist_sbin_SCRIPTS = \
718         tools/ganeti-listrunner
719
720 nodist_sbin_SCRIPTS = \
721         $(PYTHON_BOOTSTRAP_SBIN) \
722         daemons/ganeti-cleaner
723
724 if ENABLE_CONFD
725 htools/ganeti-confd: htools/hconfd
726         cp -f $< $@
727
728 nodist_sbin_SCRIPTS += htools/ganeti-confd
729 endif
730
731 python_scripts = \
732         tools/burnin \
733         tools/cfgshell \
734         tools/cfgupgrade \
735         tools/cfgupgrade12 \
736         tools/cluster-merge \
737         tools/confd-client \
738         tools/fmtjson \
739         tools/lvmstrap \
740         tools/move-instance \
741         tools/ovfconverter \
742         tools/sanitize-config
743
744 dist_tools_SCRIPTS = \
745         $(python_scripts) \
746         tools/kvm-console-wrapper \
747         tools/master-ip-setup \
748         tools/xen-console-wrapper
749
750 nodist_tools_python_scripts = \
751         tools/node-cleanup
752
753 nodist_tools_SCRIPTS = \
754         $(nodist_tools_python_scripts) \
755         tools/vcluster-setup
756
757 pkglib_python_scripts = \
758         daemons/import-export \
759         tools/check-cert-expired
760
761 nodist_pkglib_python_scripts = \
762         tools/ensure-dirs \
763         tools/node-daemon-setup \
764         tools/prepare-node-join
765
766 myexeclib_SCRIPTS = \
767         daemons/daemon-util \
768         tools/kvm-ifup \
769         $(pkglib_python_scripts) \
770         htools/mon-collector
771
772 nodist_myexeclib_SCRIPTS = \
773         $(nodist_pkglib_python_scripts)
774
775 EXTRA_DIST = \
776         NEWS \
777         UPGRADE \
778         epydoc.conf.in \
779         pylintrc \
780         autotools/build-bash-completion \
781         autotools/build-rpc \
782         autotools/check-header \
783         autotools/check-imports \
784         autotools/check-man-dashes \
785         autotools/check-man-warnings \
786         autotools/check-news \
787         autotools/check-python-code \
788         autotools/check-tar \
789         autotools/check-version \
790         autotools/convert-constants \
791         autotools/docpp \
792         autotools/gen-coverage \
793         autotools/testrunner \
794         autotools/wrong-hardcoded-paths \
795         $(RUN_IN_TEMPDIR) \
796         daemons/daemon-util.in \
797         daemons/ganeti-cleaner.in \
798         $(pkglib_python_scripts) \
799         devel/upload \
800         tools/kvm-ifup.in \
801         tools/vcluster-setup.in \
802         $(docdot) \
803         $(docpng) \
804         $(docrst) \
805         doc/conf.py \
806         doc/html \
807         $(BUILT_EXAMPLES:%=%.in) \
808         doc/examples/ganeti.default \
809         doc/examples/ganeti.default-debug \
810         doc/examples/hooks/ethers \
811         doc/examples/gnt-debug/README \
812         doc/examples/gnt-debug/delay0.json \
813         doc/examples/gnt-debug/delay50.json \
814         test/lockperf.py \
815         test/testutils.py \
816         test/mocks.py \
817         $(dist_TESTS) \
818         $(TEST_FILES) \
819         man/footer.rst \
820         $(manrst) \
821         $(maninput) \
822         qa/qa-sample.json \
823         $(qa_scripts) \
824         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
825         $(HS_PROG_SRCS) \
826         htools/lint-hints.hs \
827         htest/cli-tests-defs.sh \
828         htest/offline-test.sh \
829         .ghci
830
831 man_MANS = \
832         man/ganeti-cleaner.8 \
833         man/ganeti-confd.8 \
834         man/ganeti-listrunner.8 \
835         man/ganeti-masterd.8 \
836         man/ganeti-noded.8 \
837         man/ganeti-os-interface.7 \
838         man/ganeti-rapi.8 \
839         man/ganeti-watcher.8 \
840         man/ganeti.7 \
841         man/gnt-backup.8 \
842         man/gnt-cluster.8 \
843         man/gnt-debug.8 \
844         man/gnt-group.8 \
845         man/gnt-network.8 \
846         man/gnt-instance.8 \
847         man/gnt-job.8 \
848         man/gnt-node.8 \
849         man/gnt-os.8 \
850         man/hail.1 \
851         man/hbal.1 \
852         man/hcheck.1 \
853         man/hinfo.1 \
854         man/hscan.1 \
855         man/hspace.1 \
856         man/hroller.1 \
857         man/htools.1 \
858         man/mon-collector.7
859
860 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
861 manhtml = $(patsubst %.rst,%.html,$(manrst))
862 mangen = $(patsubst %.rst,%.gen,$(manrst))
863 maninput = \
864         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
865         $(patsubst %.html,%.html.in,$(manhtml)) \
866         man/footer.man man/footer.html $(mangen)
867
868 TEST_FILES = \
869         htest/data/common-suffix.data \
870         htest/data/hail-alloc-drbd.json \
871         htest/data/hail-change-group.json \
872         htest/data/hail-invalid-reloc.json \
873         htest/data/hail-node-evac.json \
874         htest/data/hail-reloc-drbd.json \
875         htest/data/hbal-excl-tags.data \
876         htest/data/hbal-split-insts.data \
877         htest/data/invalid-node.data \
878         htest/data/missing-resources.data \
879         htest/data/rapi/groups.json \
880         htest/data/rapi/info.json \
881         htest/data/rapi/instances.json \
882         htest/data/rapi/nodes.json \
883         htest/shelltests/htools-balancing.test \
884         htest/shelltests/htools-basic.test \
885         htest/shelltests/htools-dynutil.test \
886         htest/shelltests/htools-excl.test \
887         htest/shelltests/htools-hail.test \
888         htest/shelltests/htools-hspace.test \
889         htest/shelltests/htools-invalid.test \
890         htest/shelltests/htools-multi-group.test \
891         htest/shelltests/htools-no-backend.test \
892         htest/shelltests/htools-rapi.test \
893         htest/shelltests/htools-single-group.test \
894         htest/shelltests/htools-text-backend.test \
895         htest/shelltests/htools-mon-collector.test \
896         test/data/bdev-drbd-8.0.txt \
897         test/data/bdev-drbd-8.3.txt \
898         test/data/bdev-drbd-disk.txt \
899         test/data/bdev-drbd-net-ip4.txt \
900         test/data/bdev-drbd-net-ip6.txt \
901         test/data/cert1.pem \
902         test/data/cert2.pem \
903         test/data/ip-addr-show-dummy0.txt \
904         test/data/ip-addr-show-lo-ipv4.txt \
905         test/data/ip-addr-show-lo-ipv6.txt \
906         test/data/ip-addr-show-lo-oneline-ipv4.txt \
907         test/data/ip-addr-show-lo-oneline-ipv6.txt \
908         test/data/ip-addr-show-lo-oneline.txt \
909         test/data/ip-addr-show-lo.txt \
910         test/data/kvm_0.12.5_help.txt \
911         test/data/kvm_0.15.90_help.txt \
912         test/data/kvm_0.9.1_help.txt \
913         test/data/kvm_1.0_help.txt \
914         test/data/ovfdata/compr_disk.vmdk.gz \
915         test/data/ovfdata/config.ini \
916         test/data/ovfdata/corrupted_resources.ovf \
917         test/data/ovfdata/empty.ini \
918         test/data/ovfdata/empty.ovf \
919         test/data/ovfdata/ganeti.mf \
920         test/data/ovfdata/ganeti.ovf \
921         test/data/ovfdata/gzip_disk.ovf \
922         test/data/ovfdata/new_disk.vmdk \
923         test/data/ovfdata/no_disk.ini \
924         test/data/ovfdata/no_disk_in_ref.ovf \
925         test/data/ovfdata/no_os.ini \
926         test/data/ovfdata/no_ovf.ova \
927         test/data/ovfdata/other/rawdisk.raw \
928         test/data/ovfdata/ova.ova \
929         test/data/ovfdata/rawdisk.raw \
930         test/data/ovfdata/second_disk.vmdk \
931         test/data/ovfdata/unsafe_path.ini \
932         test/data/ovfdata/virtualbox.ovf \
933         test/data/ovfdata/wrong_config.ini \
934         test/data/ovfdata/wrong_extension.ovd \
935         test/data/ovfdata/wrong_manifest.mf \
936         test/data/ovfdata/wrong_manifest.ovf \
937         test/data/ovfdata/wrong_ova.ova \
938         test/data/ovfdata/wrong_xml.ovf \
939         test/data/proc_drbd8.txt \
940         test/data/proc_drbd80-emptyline.txt \
941         test/data/proc_drbd83.txt \
942         test/data/proc_drbd83_sync.txt \
943         test/data/proc_drbd83_sync_want.txt \
944         test/data/proc_drbd83_sync_krnl2.6.39.txt \
945         test/data/sys_drbd_usermode_helper.txt \
946         test/data/vgreduce-removemissing-2.02.02.txt \
947         test/data/vgreduce-removemissing-2.02.66-fail.txt \
948         test/data/vgreduce-removemissing-2.02.66-ok.txt \
949         test/data/vgs-missing-pvs-2.02.02.txt \
950         test/data/vgs-missing-pvs-2.02.66.txt \
951         test/ganeti-cli.test \
952         test/gnt-cli.test \
953         test/import-export_unittest-helper
954
955 python_tests = \
956         doc/examples/rapi_testutils.py \
957         test/cfgupgrade_unittest.py \
958         test/docs_unittest.py \
959         test/ganeti.asyncnotifier_unittest.py \
960         test/ganeti.backend_unittest-runasroot.py \
961         test/ganeti.backend_unittest.py \
962         test/ganeti.bdev_unittest.py \
963         test/ganeti.cli_unittest.py \
964         test/ganeti.client.gnt_cluster_unittest.py \
965         test/ganeti.client.gnt_instance_unittest.py \
966         test/ganeti.client.gnt_job_unittest.py \
967         test/ganeti.cmdlib_unittest.py \
968         test/ganeti.compat_unittest.py \
969         test/ganeti.confd.client_unittest.py \
970         test/ganeti.config_unittest.py \
971         test/ganeti.constants_unittest.py \
972         test/ganeti.daemon_unittest.py \
973         test/ganeti.errors_unittest.py \
974         test/ganeti.hooks_unittest.py \
975         test/ganeti.ht_unittest.py \
976         test/ganeti.http_unittest.py \
977         test/ganeti.hypervisor.hv_chroot_unittest.py \
978         test/ganeti.hypervisor.hv_fake_unittest.py \
979         test/ganeti.hypervisor.hv_kvm_unittest.py \
980         test/ganeti.hypervisor.hv_lxc_unittest.py \
981         test/ganeti.hypervisor.hv_xen_unittest.py \
982         test/ganeti.hypervisor_unittest.py \
983         test/ganeti.impexpd_unittest.py \
984         test/ganeti.jqueue_unittest.py \
985         test/ganeti.jstore_unittest.py \
986         test/ganeti.locking_unittest.py \
987         test/ganeti.luxi_unittest.py \
988         test/ganeti.masterd.iallocator_unittest.py \
989         test/ganeti.masterd.instance_unittest.py \
990         test/ganeti.mcpu_unittest.py \
991         test/ganeti.netutils_unittest.py \
992         test/ganeti.objects_unittest.py \
993         test/ganeti.objectutils_unittest.py \
994         test/ganeti.opcodes_unittest.py \
995         test/ganeti.ovf_unittest.py \
996         test/ganeti.qlang_unittest.py \
997         test/ganeti.query_unittest.py \
998         test/ganeti.rapi.baserlib_unittest.py \
999         test/ganeti.rapi.client_unittest.py \
1000         test/ganeti.rapi.resources_unittest.py \
1001         test/ganeti.rapi.rlib2_unittest.py \
1002         test/ganeti.rapi.testutils_unittest.py \
1003         test/ganeti.rpc_unittest.py \
1004         test/ganeti.runtime_unittest.py \
1005         test/ganeti.serializer_unittest.py \
1006         test/ganeti.server.rapi_unittest.py \
1007         test/ganeti.ssconf_unittest.py \
1008         test/ganeti.ssh_unittest.py \
1009         test/ganeti.storage_unittest.py \
1010         test/ganeti.tools.ensure_dirs_unittest.py \
1011         test/ganeti.tools.node_daemon_setup_unittest.py \
1012         test/ganeti.tools.prepare_node_join_unittest.py \
1013         test/ganeti.uidpool_unittest.py \
1014         test/ganeti.utils.algo_unittest.py \
1015         test/ganeti.utils.filelock_unittest.py \
1016         test/ganeti.utils.hash_unittest.py \
1017         test/ganeti.utils.io_unittest-runasroot.py \
1018         test/ganeti.utils.io_unittest.py \
1019         test/ganeti.utils.log_unittest.py \
1020         test/ganeti.utils.mlock_unittest.py \
1021         test/ganeti.utils.nodesetup_unittest.py \
1022         test/ganeti.utils.process_unittest.py \
1023         test/ganeti.utils.retry_unittest.py \
1024         test/ganeti.utils.text_unittest.py \
1025         test/ganeti.utils.wrapper_unittest.py \
1026         test/ganeti.utils.x509_unittest.py \
1027         test/ganeti.utils_unittest.py \
1028         test/ganeti.vcluster_unittest.py \
1029         test/ganeti.workerpool_unittest.py \
1030         test/pycurl_reset_unittest.py \
1031         test/qa.qa_config_unittest.py \
1032         test/tempfile_fork_unittest.py
1033
1034 haskell_tests = htest/test
1035
1036 dist_TESTS = \
1037         test/check-cert-expired_unittest.bash \
1038         test/daemon-util_unittest.bash \
1039         test/ganeti-cleaner_unittest.bash \
1040         test/import-export_unittest.bash \
1041         test/cli-test.bash \
1042         test/bash_completion.bash \
1043         $(python_tests)
1044
1045 nodist_TESTS =
1046 check_SCRIPTS =
1047
1048 if WANT_HTOOLSTESTS
1049 nodist_TESTS += $(haskell_tests)
1050 dist_TESTS += htest/offline-test.sh
1051 check_SCRIPTS += \
1052         htest/hpc-htools \
1053         htest/hpc-mon-collector \
1054         $(HS_BUILT_TEST_HELPERS)
1055 endif
1056
1057 TESTS = $(dist_TESTS) $(nodist_TESTS)
1058
1059 # Environment for all tests
1060 PLAIN_TESTS_ENVIRONMENT = \
1061         PYTHONPATH=. \
1062         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1063         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1064         $(RUN_IN_TEMPDIR)
1065
1066 # Environment for tests run by automake
1067 TESTS_ENVIRONMENT = \
1068         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1069
1070 all_python_code = \
1071         $(dist_sbin_SCRIPTS) \
1072         $(python_scripts) \
1073         $(pkglib_python_scripts) \
1074         $(nodist_pkglib_python_scripts) \
1075         $(nodist_tools_python_scripts) \
1076         $(python_tests) \
1077         $(pkgpython_PYTHON) \
1078         $(client_PYTHON) \
1079         $(hypervisor_PYTHON) \
1080         $(rapi_PYTHON) \
1081         $(server_PYTHON) \
1082         $(pytools_PYTHON) \
1083         $(http_PYTHON) \
1084         $(confd_PYTHON) \
1085         $(masterd_PYTHON) \
1086         $(impexpd_PYTHON) \
1087         $(utils_PYTHON) \
1088         $(watcher_PYTHON) \
1089         $(noinst_PYTHON) \
1090         $(qa_scripts)
1091
1092 srclink_files = \
1093         man/footer.rst \
1094         test/check-cert-expired_unittest.bash \
1095         test/daemon-util_unittest.bash \
1096         test/ganeti-cleaner_unittest.bash \
1097         test/import-export_unittest.bash \
1098         test/cli-test.bash \
1099         test/bash_completion.bash \
1100         htest/offline-test.sh \
1101         htest/cli-tests-defs.sh \
1102         $(all_python_code) \
1103         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1104
1105 check_python_code = \
1106         $(BUILD_BASH_COMPLETION) \
1107         $(CHECK_IMPORTS) \
1108         $(CHECK_HEADER) \
1109         $(DOCPP) \
1110         $(all_python_code)
1111
1112 lint_python_code = \
1113         ganeti \
1114         ganeti/http/server.py \
1115         $(dist_sbin_SCRIPTS) \
1116         $(python_scripts) \
1117         $(pkglib_python_scripts) \
1118         $(BUILD_BASH_COMPLETION) \
1119         $(CHECK_IMPORTS) \
1120         $(CHECK_HEADER) \
1121         $(DOCPP) \
1122         $(PYTHON_BOOTSTRAP)
1123
1124 standalone_python_modules = \
1125         lib/rapi/client.py \
1126         tools/ganeti-listrunner
1127
1128 pep8_python_code = \
1129         ganeti \
1130         ganeti/http/server.py \
1131         $(dist_sbin_SCRIPTS) \
1132         $(python_scripts) \
1133         $(pkglib_python_scripts) \
1134         $(BUILD_BASH_COMPLETION) \
1135         $(CHECK_HEADER) \
1136         $(DOCPP) \
1137         $(PYTHON_BOOTSTRAP) \
1138         qa
1139
1140 test/daemon-util_unittest.bash: daemons/daemon-util
1141
1142 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1143
1144 test/bash_completion.bash: doc/examples/bash_completion-debug
1145
1146 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1147         sed -f $(REPLACE_VARS_SED) < $< > $@
1148         chmod +x $@
1149
1150 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1151         sed -f $(REPLACE_VARS_SED) < $< > $@
1152         chmod +x $@
1153
1154 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1155         sed -f $(REPLACE_VARS_SED) < $< > $@
1156         chmod +x $@
1157
1158 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1159         sed -f $(REPLACE_VARS_SED) < $< > $@
1160
1161 doc/examples/bash_completion: BC_ARGS = --compact
1162 doc/examples/bash_completion-debug: BC_ARGS =
1163
1164 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1165         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1166         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1167         daemons/ganeti-cleaner \
1168         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1169         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1170           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1171
1172 doc/%.png: doc/%.dot
1173         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1174         $(DOT) -Tpng -o $@ $<
1175
1176 man/footer.man: man/footer.rst
1177         @test -n "$(PANDOC)" || \
1178           { echo 'pandoc' not found during configure; exit 1; }
1179         $(PANDOC) -f rst -t man -o $@ $<
1180
1181 man/footer.html: man/footer.rst
1182         @test -n "$(PANDOC)" || \
1183           { echo 'pandoc' not found during configure; exit 1; }
1184         $(PANDOC) -f rst -t html -o $@ $<
1185
1186 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1187         lib/build/shell_example_lexer.py \
1188         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1189         @echo "Checking $< for hardcoded paths..."
1190         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1191           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1192           exit 1; \
1193         fi
1194         set -e ; \
1195         trap 'echo auto-removing $@; rm $@' EXIT; \
1196         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1197         trap - EXIT
1198
1199 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1200         @test -n "$(PANDOC)" || \
1201           { echo 'pandoc' not found during configure; exit 1; }
1202         set -o pipefail ; \
1203         trap 'echo auto-removing $@; rm $@' EXIT; \
1204         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1205           sed -e 's/\\@/@/g' > $@; \
1206         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1207         $(CHECK_MAN_DASHES) $@; \
1208         trap - EXIT
1209
1210
1211 man/%.html.in: man/%.gen man/footer.html
1212         @test -n "$(PANDOC)" || \
1213           { echo 'pandoc' not found during configure; exit 1; }
1214         set -o pipefail ; \
1215         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1216           sed -e 's/\\@/@/g' > $@
1217
1218 man/%: man/%.in  $(REPLACE_VARS_SED)
1219         sed -f $(REPLACE_VARS_SED) < $< > $@
1220
1221 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1222         sed -f $(REPLACE_VARS_SED) < $< > $@
1223
1224 vcs-version:
1225         if test -d .git; then \
1226           git describe > $@; \
1227         elif test ! -f $@ ; then \
1228           echo "Cannot auto-generate $@ file"; exit 1; \
1229         fi
1230
1231 .PHONY: clean-vcs-version
1232 clean-vcs-version:
1233         rm -f vcs-version
1234
1235 .PHONY: regen-vcs-version
1236 regen-vcs-version:
1237         @set -e; \
1238         cd $(srcdir); \
1239         if test -d .git; then \
1240           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1241           git describe > $$T; \
1242           if ! cmp --quiet $$T vcs-version; then \
1243             mv $$T vcs-version; \
1244           fi; \
1245         fi
1246
1247 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1248         vcs-version $(built_base_sources)
1249         set -e; \
1250         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1251         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1252
1253 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1254         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1255         lib/jstore.py \
1256         $(CONVERT_CONSTANTS) $(built_base_sources) \
1257         | lib/_vcsversion.py
1258         set -e; \
1259         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1260
1261 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1262         $(built_base_sources)
1263         set -e; \
1264         { cat $< ; \
1265           echo ; \
1266           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1267             echo "import $$name ()" ; \
1268           done ; \
1269         } > $@
1270
1271 lib/_autoconf.py: Makefile | stamp-directories
1272         set -e; \
1273         { echo '# This file is automatically generated, do not edit!'; \
1274           echo '#'; \
1275           echo ''; \
1276           echo '"""Build-time configuration for Ganeti.'; \
1277           echo '';\
1278           echo 'This file is autogenerated by the build process.'; \
1279           echo 'For any changes you need to re-run ./configure (and'; \
1280           echo 'not edit by hand).'; \
1281           echo ''; \
1282           echo '"""'; \
1283           echo ''; \
1284           echo '# pylint: disable=C0301,C0324'; \
1285           echo '# because this is autogenerated, we do not want'; \
1286           echo '# style warnings' ; \
1287           echo ''; \
1288           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1289           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1290           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1291           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1292           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1293           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1294           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1295           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1296           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1297           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1298           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1299           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1300           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1301           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1302           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1303           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1304           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1305           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1306           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1307           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1308           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1309           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1310           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1311           echo "KVM_PATH = '$(KVM_PATH)'"; \
1312           echo "IP_PATH = '$(IP_PATH)'"; \
1313           echo "SOCAT_PATH = '$(SOCAT)'"; \
1314           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1315           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1316           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1317           echo "TOOLSDIR = '$(toolsdir)'"; \
1318           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1319           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1320           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1321           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1322           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1323           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1324           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1325           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1326           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1327           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1328           echo "RAPI_USER = '$(RAPI_USER)'"; \
1329           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1330           echo "CONFD_USER = '$(CONFD_USER)'"; \
1331           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1332           echo "NODED_USER = '$(NODED_USER)'"; \
1333           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1334           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1335           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1336           echo "HTOOLS = True"; \
1337           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1338           echo "XEN_CMD = '$(XEN_CMD)'"; \
1339           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1340           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1341           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1342         } > $@
1343
1344 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1345         set -e; \
1346         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1347         { echo '# This file is automatically generated, do not edit!'; \
1348           echo '#'; \
1349           echo ''; \
1350           echo '"""Build-time VCS version number for Ganeti.'; \
1351           echo '';\
1352           echo 'This file is autogenerated by the build process.'; \
1353           echo 'For any changes you need to re-run ./configure (and'; \
1354           echo 'not edit by hand).'; \
1355           echo ''; \
1356           echo '"""'; \
1357           echo ''; \
1358           echo '# pylint: disable=C0301,C0324'; \
1359           echo '# because this is autogenerated, we do not want'; \
1360           echo '# style warnings' ; \
1361           echo ''; \
1362           echo "VCS_VERSION = '$$VCSVER'"; \
1363         } > $@
1364
1365 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1366         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1367
1368 $(SHELL_ENV_INIT): Makefile stamp-directories
1369         set -e; \
1370         { echo '# Allow overriding for tests'; \
1371           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1372           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1373           echo; \
1374           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1375           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1376           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1377           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1378           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1379         } > $@
1380
1381 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1382         set -e; \
1383         { echo 's#@PREFIX@#$(prefix)#g'; \
1384           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1385           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1386           echo 's#@BINDIR@#$(bindir)#g'; \
1387           echo 's#@SBINDIR@#$(sbindir)#g'; \
1388           echo 's#@LIBDIR@#$(libdir)#g'; \
1389           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1390           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1391           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1392           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1393           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1394           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1395           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1396           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1397           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1398           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1399           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1400           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1401           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1402           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1403           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1404           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1405           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1406           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1407           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1408           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1409           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1410           echo; \
1411           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1412           echo '  r $(SHELL_ENV_INIT)'; \
1413           echo '  d'; \
1414           echo '}'; \
1415         } > $@
1416
1417 # Using deferred evaluation
1418 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1419 daemons/ganeti-watcher: MODULE = ganeti.watcher
1420 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1421 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1422 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1423 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1424 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1425 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1426
1427 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1428         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1429         set -e; \
1430         { echo '#!/usr/bin/python'; \
1431           echo '# This file is automatically generated, do not edit!'; \
1432           echo "# Edit $(MODULE) instead."; \
1433           echo; \
1434           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1435           echo; \
1436           echo '# pylint: disable=C0103'; \
1437           echo '# C0103: Invalid name'; \
1438           echo; \
1439           echo 'import sys'; \
1440           echo 'import $(MODULE) as main'; \
1441           echo; \
1442           echo '# Temporarily alias commands until bash completion'; \
1443           echo '# generator is changed'; \
1444           echo 'if hasattr(main, "commands"):'; \
1445           echo '  commands = main.commands # pylint: disable=E1101'; \
1446           echo 'if hasattr(main, "aliases"):'; \
1447           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1448           echo; \
1449           echo 'if __name__ == "__main__":'; \
1450           echo '  sys.exit(main.Main())'; \
1451         } > $@
1452         chmod u+x $@
1453
1454 $(HS_BUILT_TEST_HELPERS): Makefile
1455         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1456         set -e; \
1457         { echo '#!/bin/sh'; \
1458           echo '# This file is automatically generated, do not edit!'; \
1459           echo "# Edit Makefile.am instead."; \
1460           echo; \
1461           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1462         } > $@
1463         chmod u+x $@
1464
1465 stamp-directories: Makefile
1466         $(MAKE) $(AM_MAKEFLAGS) ganeti
1467         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1468         touch $@
1469
1470 # We need to create symlinks because "make distcheck" will not install Python
1471 # files when building.
1472 stamp-srclinks: Makefile | stamp-directories
1473         set -e; \
1474         for i in $(srclink_files); do \
1475           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1476             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1477           fi; \
1478         done
1479         touch $@
1480
1481 .PHONY: ganeti
1482 ganeti:
1483         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1484
1485 .PHONY: check-dirs
1486 check-dirs: $(GENERATED_FILES)
1487         @set -e; \
1488         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1489           error=; \
1490           while read dir; do \
1491             case "$$dir" in \
1492               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1493               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1494             esac; \
1495           done; \
1496           for dir in $(DIRS); do \
1497             if ! test -d "$$dir"; then \
1498               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1499               error=1; \
1500             fi \
1501           done; \
1502           test -z "$$error"; \
1503         }
1504
1505 .PHONY: check-local
1506 check-local: check-dirs $(GENERATED_FILES)
1507         $(CHECK_PYTHON_CODE) $(check_python_code)
1508         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1509         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1510         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1511         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1512         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1513         error= ; \
1514         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1515           echo "Incorrect version in README, expected $$expver" >&2; \
1516           error=1; \
1517         fi; \
1518         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1519             doc/security.rst; do \
1520           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1521             "Documents Ganeti version $$expver"; then \
1522             echo "Incorrect version in $$file, expected $$expver" >&2; \
1523             error=1; \
1524           fi; \
1525         done; \
1526         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1527           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1528           error=1; \
1529         fi; \
1530         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1531           ".. Last updated for Ganeti $$expver"; then \
1532           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1533           error=1; \
1534         fi; \
1535         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1536           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1537             echo "Longest line in $$file is longer than 80 characters" >&2; \
1538             error=1; \
1539           fi; \
1540         done; \
1541         test -z "$$error"
1542
1543 .PHONY: hs-check
1544 hs-check: htest/test htest/hpc-htools htest/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1545         @rm -f *.tix
1546         ./htest/test
1547         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1548
1549 # E111: indentation is not a multiple of four
1550 # E121: continuation line indentation is not a multiple of four
1551 #       (since our indent level is not 4)
1552 # E125: continuation line does not distinguish itself from next logical line
1553 #       (since our indent level is not 4)
1554 # E127: continuation line over-indented for visual indent
1555 #       (since our indent level is not 4)
1556 # note: do NOT add E128 here; it's a valid style error in most cases!
1557 # I've seen real errors, but also some cases were we indent wrongly
1558 # due to line length; try to rework the cases where it is triggered,
1559 # instead of silencing it
1560 # E261: at least two spaces before inline comment
1561 # E501: line too long (80 characters)
1562 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1563
1564 # For excluding pep8 expects filenames only, not whole paths
1565 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1566
1567 LINT_TARGETS = pylint pylint-qa
1568 if HAS_PEP8
1569 LINT_TARGETS += pep8
1570 endif
1571 if HAS_HLINT
1572 LINT_TARGETS += hlint
1573 endif
1574
1575 .PHONY: lint
1576 lint: $(LINT_TARGETS)
1577
1578 .PHONY: pylint
1579 pylint: $(GENERATED_FILES)
1580         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1581         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1582
1583 .PHONY: pylint-qa
1584 pylint-qa: $(GENERATED_FILES)
1585         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1586         cd $(top_srcdir)/qa && \
1587           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1588           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1589
1590 .PHONY: pep8
1591 pep8: $(GENERATED_FILES)
1592         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1593         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1594           --repeat $(pep8_python_code)
1595
1596 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1597 HLINT_EXCLUDES = htools/Ganeti/THH.hs htest/hpc-htools.hs
1598 .PHONY: hlint
1599 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1600         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1601         if tty -s; then C="-c"; else C=""; fi; \
1602         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1603           --ignore "Use first" \
1604           --ignore "Use &&&" \
1605           --ignore "Use void" \
1606           --ignore "Reduce duplication" \
1607           --hint htools/lint-hints \
1608           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1609
1610 # a dist hook rule for updating the vcs-version file; this is
1611 # hardcoded due to where it needs to build the file...
1612 dist-hook:
1613         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1614         rm -f $(top_distdir)/vcs-version
1615         cp -p $(srcdir)/vcs-version $(top_distdir)
1616
1617 # a distcheck hook rule for catching revision control directories
1618 distcheck-hook:
1619         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1620           echo "Found revision control files in final archive." 1>&2; \
1621           exit 1; \
1622         fi
1623         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1624           echo "Found Python byte code in final archive." 1>&2; \
1625           exit 1; \
1626         fi
1627         if find $(top_distdir) -name '*~' | grep .; then \
1628           echo "Found backup files in final archive." 1>&2; \
1629           exit 1; \
1630         fi
1631 # Empty files or directories should not be distributed. They can cause
1632 # unnecessary warnings for packagers. Directories used by automake during
1633 # distcheck must be excluded.
1634         if find $(top_distdir) -empty -and -not \( \
1635             -path $(top_distdir)/_build -or \
1636             -path $(top_distdir)/_inst \) | grep .; then \
1637           echo "Found empty files or directories in final archive." 1>&2; \
1638           exit 1; \
1639         fi
1640         if test -n "$(BUILD_RELEASE)" && \
1641            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1642            echo "Found unreleased version in NEWS." >&2; \
1643            exit 1; \
1644         fi
1645
1646 # When building a release, stricter checks should be used
1647 distcheck-release dist-release: export BUILD_RELEASE = 1
1648 distcheck-release: distcheck
1649
1650 distrebuildcheck: dist
1651         set -e; \
1652         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1653         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1654         cd $$builddir; \
1655         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1656         cd $(distdir); \
1657         ./configure; \
1658         $(MAKE) maintainer-clean; \
1659         cp $(abs_srcdir)/vcs-version .; \
1660         ./configure; \
1661         $(MAKE) $(AM_MAKEFLAGS)
1662
1663 dist-release: dist
1664         set -e; \
1665         for i in $(DIST_ARCHIVES); do \
1666           echo -n "Checking $$i ... "; \
1667           autotools/check-tar < $$i; \
1668           echo OK; \
1669         done
1670
1671 install-exec-local:
1672         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1673           "$(DESTDIR)${localstatedir}/log/ganeti" \
1674           "$(DESTDIR)${localstatedir}/run/ganeti"
1675
1676 .PHONY: apidoc
1677 if WANT_HTOOLSAPIDOC
1678 apidoc: py-apidoc hs-apidoc
1679 else
1680 apidoc: py-apidoc
1681 endif
1682
1683 .PHONY: py-apidoc
1684 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1685         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1686         $(RUN_IN_TEMPDIR) epydoc -v \
1687           --conf $(CURDIR)/epydoc.conf \
1688           --output $(CURDIR)/$(APIDOC_PY_DIR)
1689
1690 .PHONY: hs-apidoc
1691 hs-apidoc: $(HS_BUILT_SRCS)
1692         @test -n "$(HSCOLOUR)" || \
1693             { echo 'HsColour' not found during configure; exit 1; }
1694         @test -n "$(HADDOCK)" || \
1695             { echo 'haddock' not found during configure; exit 1; }
1696         rm -rf $(APIDOC_HS_DIR)/*
1697         for i in $(ALL_APIDOC_HS_DIRS); do \
1698           @mkdir_p@ $$i; \
1699         done
1700         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1701         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1702         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1703         set -e ; \
1704         cd htools; \
1705         if [ "$(HTOOLS_NOCURL)" ]; \
1706         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1707         else OPTGHC=""; \
1708         fi; \
1709         if [ "$(HTOOLS_PARALLEL3)" ]; \
1710         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1711         fi; \
1712         if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1713         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1714         fi; \
1715         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1716         for file in $$RELSRCS; do \
1717           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1718           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1719         done ; \
1720         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1721           -t ganeti -p haddock-prologue \
1722           --source-module="%{MODULE/.//}.html" \
1723           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1724           $$OPTGHC \
1725           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1726
1727 .PHONY: TAGS
1728 TAGS: $(GENERATED_FILES)
1729         rm -f TAGS
1730         $(GHC) -e ":etags" -v0 \
1731           $(filter-out -O -Werror,$(HFLAGS)) \
1732           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1733           $(HS_LIBTEST_SRCS)
1734         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1735           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1736           -path './qa/*.py' | \
1737           etags -l python -a -
1738
1739 .PHONY: coverage
1740 if WANT_HTOOLS
1741 coverage: py-coverage hs-coverage
1742 else
1743 coverage: py-coverage
1744 endif
1745
1746 .PHONY: py-coverage
1747 py-coverage: $(GENERATED_FILES) $(python_tests)
1748         @test -n "$(PYCOVERAGE)" || \
1749             { echo 'python-coverage' not found during configure; exit 1; }
1750         set -e; \
1751         COVERAGE=$(PYCOVERAGE) \
1752         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1753         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1754         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1755         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1756         $(python_tests)
1757
1758 .PHONY: hs-coverage
1759 hs-coverage: $(haskell_tests) htest/hpc-htools htest/hpc-mon-collector
1760         rm -f *.tix
1761         $(MAKE) $(AM_MAKEFLAGS) hs-check
1762         @mkdir_p@ $(COVERAGE_HS_DIR)
1763         hpc sum --union $(HPCEXCL) \
1764           test.tix hpc-htools.tix hpc-mon-collector.tix > coverage-htools.tix
1765         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1766         hpc report coverage-htools.tix
1767         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1768
1769 # Special "kind-of-QA" target for htools, needs special setup (all
1770 # tools compiled with -fhpc)
1771 .PHONY: live-test
1772 live-test: all
1773         set -e ; \
1774         cd htools; \
1775         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1776         rm -f *.tix *.mix; \
1777         ./live-test.sh; \
1778         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1779           --output=live-test.tix ; \
1780         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1781         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1782           --srcdir=.. $(HPCEXCL) ; \
1783         hpc report --srcdir=.. live-test $(HPCEXCL)
1784
1785 commit-check: distcheck lint apidoc
1786
1787 .PHONY: gitignore-check
1788 gitignore-check:
1789         @if [ -n "`git status --short`" ]; then \
1790           echo "Git status is not clean!" 1>&2 ; \
1791           git status --short; \
1792           exit 1; \
1793         fi
1794
1795 # Target that builds all binaries (including those that are not
1796 # rebuilt except when running the tests)
1797 .PHONY: really-all
1798 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1799
1800 # we don't need the ancient implicit rules:
1801 %: %,v
1802 %: RCS/%,v
1803 %: RCS/%
1804 %: s.%
1805 %: SCCS/s.%
1806
1807 -include ./Makefile.local
1808
1809 # vim: set noet :